/*
  CPP_CONTEST=2015
  CPP_PROBLEM=A
  CPP_LANG=CPP+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=mercurio 1
*/

// 2

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <mpi.h>
 
void multiplication(double *a,int n,int ld)
{
  double *r=new double[n*n];

  for(int i=0;i<n;i++)
  {
    for(int j=0;j<n;j++)
    {
       double s=0.;
       for(int k=0;k<n;k++)
       {
         s+=a[i*ld+k]*a[k*ld+j];
       }
       r[i*n+j]=s;
    }
  }
  
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<n;j++)
    {
       a[i*ld+j]=r[i*n+j];
    }
  }

  delete [] r;
}

void multiplications(int N,int M,int L,double *A)
{
  for(int pos=0;pos<=N-M;pos+=M-L)
  {
    multiplication(&A[pos*N+pos],M,N);
  }
}

void update(int n,double *a,double d)
{
  for(int i=0;i<n*n;i++)
  {
    a[i]/=d;
  }
}

void  sec(int N,int M,int L,int S,double *A,int nodo,int np)
{
  update(N,A,10.);
  for(int step=0;step<S;step++)
  {
     multiplications(N,M,L,A);
  }
}

