/*
  CPP_CONTEST=2015
  CPP_PROBLEM=C
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=jupiter 1
*/

// 4

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    

using namespace std;

void escribirsubmatrix(int n,int m,int ld,double *a){
  int i, j;

  for (i = 0; i < n; i++)
  {
    for (j = 0; j < m; j++)
    {  
      cout << setiosflags(ios::fixed) << setprecision(4) <<a[i*ld+j]<<" ";
    }
    cout <<endl;
  }
  cout <<endl;
}

void copymatrix(int n,int m,double *o,double *d)
{
  int i;

  for(i=0;i<n*m;i++)
  {
    d[i]=o[i];
  }
}

double sumsubmatrix(int n,int m,int ld,double *a)
{
  double s=0.;
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<m;j++)
    {
      s+=a[i*ld+j];
    }
  }
  return s;
}

void  sec(int N,int M,int *R,int *C,double *A)
{
  double *temp=new double[N*M];

  for(int i=0;i<N;i++)
  {
     for(int j=0;j<M;j++)
     {
        double sum=0.;
        int lr=i+R[i*M+j]; //last row
        int lc=j+C[i*M+j]; //last column
        if(lr<N and lc<M) //if the rows and columns do not go out of the matrix
        {
           sum+=sumsubmatrix(lr+1-i,lc+1-j,M,&A[i*M+j]);
#ifdef DEBUG
           cout << "Submatrix does not go outside the matrix, sum of position "<<i<<" "<<j<<": "<<sum<<endl;
           escribirsubmatrix(lr+1-i,lc+1-j,M,&A[i*M+j]);
#endif
         } else if(lr>=N and lc<M) //the rows go outside the matrix, but the columns do not
        {
           sum+=sumsubmatrix(N-i,lc+1-j,M,&A[i*M+j]);
           sum+=sumsubmatrix(lr%N+1,lc+1-j,M,&A[j]); //the upper matrix obtained cyclically
        } else if(lr<N and lc>=M) //the rows go outside the matrix, but the columns do not
        {
           sum+=sumsubmatrix(lr+1-i,M-j,M,&A[i*M+j]);
           sum+=sumsubmatrix(lr+1-i,lc%M+1,M,&A[i*M]); //the left matrix obtained cyclically
        }
        else
        {
           sum+=sumsubmatrix(N-i,M-j,M,&A[i*M+j]);
           sum+=sumsubmatrix(lr%N+1,M-j,M,&A[j]); //the upper matrix obtained cyclically
           sum+=sumsubmatrix(N-i,lr%M+1,M,&A[i*M]); //the left matrix obtained cyclically
           sum+=sumsubmatrix(lr%N+1,lr%M+1,M,A); //the upper-left matrix obtained cyclically
        }
        temp[i*M+j]=sum;
     }
  }
  copymatrix(N,M,temp,A);
  delete[] temp;
}

